//+------------------------------------------------------------------+
//|                                 Test_CHARTEVENT_CHART_CHANGE.mq5 |
//|                                  Copyright 2021, MetaQuotes Ltd. |
//|                  https://www.mql5.com/ru/users/nikolay7ko/seller |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Ltd."
#property link      "https://www.mql5.com/ru/users/nikolay7ko/seller"
#property version   "1.00"
#property indicator_chart_window
#include <Canvas\iCanvas_CB.mqh> //https://www.mql5.com/ru/code/22164

bool ok = true;
//+------------------------------------------------------------------+
int OnInit() {
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[]) {
   return(rates_total);
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam) {
   if (id == CHARTEVENT_CHART_CHANGE) Draw();
}
//+------------------------------------------------------------------+
void Draw() {
   static uint last = 0;
   uint cur = GetTickCount();
   if (cur-last<30) return;
   last = cur;
   Canvas.Erase();
   for(double i = W.Right_bar; i<=W.Left_bar; i+=10 ) Canvas.FillCircle((int)_X(i),(int)_Y(iClose(NULL,0,(int)i)),8,0x80A02020);
   Canvas.Update();
}
//+------------------------------------------------------------------+
